package com.example.profesor;

import java.util.Vector;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

public class BaseDatos extends SQLiteOpenHelper {
	String nombre;
	Context contexto;

	public BaseDatos(Context context) {
		// Los parametros son: (1) el contexto, (2) nombre de la base de datos
		// (en mem. interna)
		// (3) un cursor, pero no necesitamos (4) version de la B.Datos
		// super(context, "puntuaciones", null, 1);
		super(context, "puntuaciones", null, 1);
		nombre = "puntuaciones";
		contexto = context;
	}

	public BaseDatos(Context context, String nombreb) {
		// Los parametros son: (1) el contexto, (2) nombre de la base de datos
		// (en mem. interna)
		// (3) un cursor, pero no necesitamos (4) version de la B.Datos
		// super(context, "puntuaciones", null, 1);
		super(context, nombreb, null, 1);
		nombre = nombreb;
		contexto = context;
	}

	// Mtodos de SQLiteOpenHelper

	@Override
	public void onCreate(SQLiteDatabase db) {
		db.execSQL("CREATE TABLE "
				+ nombre
				+ " ("
				+ "_id INTEGER PRIMARY KEY AUTOINCREMENT, "
				+ " pregunta TEXT, numero INTEGER, A INTEGER, B INTEGER, C INTEGER, D INTEGER, Solucion INTEGER)");
		//Toast.makeText(contexto, "onCreate BASE DE DATOS", Toast.LENGTH_SHORT).show();
		
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		// En caso de una nueva versin habra que actualizar las tablas

	}

	public void Escribir(String preg, int num, int a, int b, int c, int d, int sol) {
		SQLiteDatabase db = getWritableDatabase();
		db.execSQL("INSERT INTO " + nombre + " VALUES (null, '" + preg + "', "
		       + num + " ," + a + " ," + b + " ," + c + " ," + d + " ," + sol + ")");
		db.close();
	}
	
	public void Borrar(int p){
		SQLiteDatabase db = getWritableDatabase();
		db.execSQL("DELETE FROM " + nombre +" WHERE (numero = "+ p + ")");
		db.close();
	}
	public void Borrar() {
		SQLiteDatabase db = getWritableDatabase();
		db.execSQL("DELETE FROM " + nombre +" WHERE 1 ");
		db.close();
	}

	public Vector<String> LeerEntera() {
		Vector<String> result = new Vector<String>();
		SQLiteDatabase db = getReadableDatabase();

		// Probando rawQuery: consulta (1)
		// Cursor cursor = db.rawQuery("SELECT puntos, nombre FROM "
		// + "puntuaciones ORDER BY puntos DESC LIMIT " + cantidad, null);

		// Misma consulta (1) con query
		String[] columnas = { "pregunta", "numero", "A", "B", "C", "D", "Solucion" };
		// FROM SELECT WHERE ? GROUP BY cond ORDER BY LIMIT
		Cursor cursor = db.query(nombre, columnas, null, null, null, null,
				null, null);
		String linea;
		int aciertos, fallos, solu, A, B, C, D;

		float TAciertos= 0, LAciertos;
		int i=0;
		while (cursor.moveToNext()) {
			solu = cursor.getInt(6);
			A = cursor.getInt(2); // A
			B = cursor.getInt(3); // B
			C = cursor.getInt(4); // C
			D = cursor.getInt(5); // D
			fallos = A + B + C + D;
			switch (solu) {
			case 0:
				aciertos = A;
				fallos -= aciertos;

				linea = String.format(
						"%s \t %d \t %d \t %d \t %d \t A \t %d \t %d",
						cursor.getString(0), A, B, C, D, aciertos, fallos);
				break;
			case 1:
				aciertos = B;
				fallos -= aciertos;

				linea = String.format(
						"%s \t %d \t %d \t %d \t %d \t B \t %d \t %d",
						cursor.getString(0), A, B, C, D, aciertos, fallos);
				break;
			case 2:
				aciertos = C;
				fallos -= aciertos;
				linea = String.format(
						"%s \t %d \t %d \t %d \t %d \t C \t %d \t %d",
						cursor.getString(0), A, B, C, D, aciertos, fallos);
				break;
			case 3:
				aciertos = D;
				fallos -=aciertos;
				linea = String.format(
						"%s \t %d \t %d \t %d \t %d \t D \t %d \t %d",
						cursor.getString(0), A, B, C, D, aciertos, fallos);
				break;
			default:
				aciertos = 0;
				linea = "";
			}

			// result.add(cursor.getString(0) + " " + // pregunta
			// cursor.getInt(1) + " " + // A
			// cursor.getInt(2) + " " + // B
			// cursor.getInt(3) + " " + // C
			// cursor.getInt(4) + " " + // D
			// cursor.getInt(5));// Solucion
			result.add(linea);
			
			
			LAciertos = (float) aciertos / (float) (aciertos+fallos) * 100 ;
			TAciertos += LAciertos;
			i++;
			
		}

        if (i > 0) TAciertos /= i;
		linea = String.format(
					"En total hay %d %s aciertos y %d %s fallos", (int)TAciertos,
					"%", 100 - (int)TAciertos, "%");
		result.add(linea);
		
		cursor.close();
		db.close();
		return result;
	}
	
	public Vector<Integer> Aciertos() {
		Vector<Integer> result = new Vector<Integer>();
		SQLiteDatabase db = getReadableDatabase();

		// Probando rawQuery: consulta (1)
		// Cursor cursor = db.rawQuery("SELECT puntos, nombre FROM "
		// + "puntuaciones ORDER BY puntos DESC LIMIT " + cantidad, null);

		// Misma consulta (1) con query
		String[] columnas = { "pregunta","numero", "A", "B", "C", "D", "Solucion" };
		// FROM SELECT WHERE ? GROUP BY cond ORDER BY LIMIT
		Cursor cursor = db.query(nombre, columnas, null, null, null, null,
				null, null);
		String linea;
		int aciertos, fallos, solu, A, B, C, D,taciertos, tfallos,i;
		float TAciertos=0, LAciertos;
		i =0 ;
		while (cursor.moveToNext()) {
			solu = cursor.getInt(6);
			A = cursor.getInt(2); // A
			B = cursor.getInt(3); // B
			C = cursor.getInt(4); // C
			D = cursor.getInt(5); // D
			fallos = A + B + C + D;
			switch (solu) {
			case 0:
				aciertos = A;
				fallos -= aciertos;

				break;
			case 1:
				aciertos = B;
				fallos -= aciertos;

				break;
			case 2:
				aciertos = C;
	            fallos -= aciertos;
				break;
			case 3:
				aciertos = D;
				fallos -=aciertos;
				break;
			default:
				aciertos = 0;
			}
            LAciertos = (float) aciertos / (float) (aciertos+fallos) * 100;
            TAciertos += LAciertos;
            i++;
		}
		
		if (i >0) TAciertos /= i;
		result.add((int)TAciertos);
		result.add(100-(int)TAciertos);

		cursor.close();
		db.close();
		return result;
	}
}
