package com.example.profesor;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Paint.Style;
import android.graphics.Typeface;
import android.util.AttributeSet;
import android.util.Log;
import android.view.View;


public class DiagramaBarras extends View {
	public int A, B, C, D;
		
		int Alto = 0;
		int Ancho = 0;
		int holgura = 0;
		int distancia = 0;
		int anchob= 50; // Es la anchura en dp de una barra
		int letra = 30;
		
	    public DiagramaBarras (Context context, AttributeSet attrs) {
	                super(context,attrs);
	                Inicializa(20, 30, 20, 30);
	                                
	    }
	    public void Inicializa(int a, int b, int c, int d){
	    	A = a;
	    	B = b;
	    	C = c;
	    	D = d;
	    }
	    
	    @Override protected void onSizeChanged(int ancho, int alto,
	                       int ancho_anterior, int alto_anterior){
	                //miImagen.setBounds(0, 0, ancho, alto);
	                Alto = alto;
	                Ancho = ancho;
	                anchob = Ancho / 9;
	                holgura = (Ancho - 4*anchob)/5;
	                distancia = holgura + anchob;
		            if (ancho < 300) letra = 10;
	    }
	            
	    @Override
	     protected void onDraw(Canvas canvas) {
	
            int x1 = holgura;
	    	Barra(canvas,A, x1,Color.GREEN); // valor y eje x
	    	BarraPuntos(canvas, 100, x1);
	    	
	    	String leyenda = String.format("%d", A);
	    	leyenda = leyenda + " %";
	    	Letra(canvas,leyenda, x1+anchob/4, Alto);
	    	
	    	x1 += distancia;
	    	Barra(canvas,B, x1,Color.RED); // valor y eje x 	
	    	BarraPuntos(canvas, 100, x1);
	    	leyenda = String.format("%d", B);
	    	leyenda = leyenda + " %";
	    	Letra(canvas,leyenda, x1+anchob/4, Alto);
	    	
	    	x1 += distancia;
	    	Barra(canvas,C, x1, Color.MAGENTA); // valor y eje x 	 
	    	BarraPuntos(canvas, 100, x1);
	    	leyenda = String.format("%d", C);
	    	leyenda = leyenda + " %";
	    	Letra(canvas,leyenda, x1+anchob/4, Alto);
	    	
	    	x1 += distancia;
	    	Barra(canvas,D, x1,Color.YELLOW); // valor y eje x
	    	BarraPuntos(canvas, 100, x1);
	    	leyenda = String.format("%d", D);
	    	leyenda = leyenda + " %";
	    	Letra(canvas,leyenda, x1+anchob/4, Alto);
	    }
	  
	    protected void BarraPuntos(Canvas canvas, int valor, int desp){
	    	int color;
	    	int coordX, coordY;
	    	
	    	int MaxY = Alto -40;
	    	
	    	coordX = desp;
	    	coordY = (int ) (MaxY * (100 - valor) / 100);
	    	Paint pincel = new Paint();
	    	pincel.setColor(Color.BLACK);
	    
	    	
	    	pincel.setStrokeWidth(6);
	    	pincel.setStyle(Style.STROKE);
	    	
    	
	    	canvas.drawRect((float) coordX, (float) coordY, (float) (coordX+anchob), (float)MaxY, pincel); 
	    	
	    }
	    protected void Barra(Canvas canvas, int valor, int desp, int color){
	    
	    	int coordX, coordY;
	    	
	    	int MaxY = Alto -40;
	    	
	    	coordX = desp;
	    	coordY = (int ) (MaxY * (100 - valor) / 100);
	    	Paint pincel = new Paint();
	    	pincel.setColor(color);
	    
	    	
	    	pincel.setStrokeWidth(6);
	    	pincel.setStyle(Style.FILL);
	    	
    	
	    	canvas.drawRect((float) coordX, (float) coordY, (float) (coordX+anchob), (float)MaxY, pincel); 
	    	
	    }
	    protected void Letra(Canvas canvas, String texto, int dx, int dy){
		
			
			Paint pincel = new Paint();
			pincel.setColor(Color.BLUE);
			pincel.setStrokeWidth(8);
			//pincel.setStyle(Style.STROKE);
			
			pincel.setStrokeWidth(1);
			pincel.setStyle(Style.FILL);
			pincel.setTextSize(letra);
			pincel.setTypeface(Typeface.SANS_SERIF);
			if (letra == 10){
     	   	    canvas.drawText(texto, dx, dy-10,  pincel); 
			}else canvas.drawText(texto, dx, dy,  pincel);
		    }
	}

