package com.example.profesor;

import java.util.Vector;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class MainActivity extends ActionBarActivity {
	public Intent i, j;
	private String Titulo_encuesta;

	// ojo, hay que cambiarlo tambien en encuesta.java
	// ponerlo en preferencias en un futuro
	// ServidorPHP servidor = new ServidorPHP("http://192.168.1.150:8080"); //
	// En casa
	ServidorPHP servidor = new ServidorPHP("http://www.milagros.hostinazo.com"); // Hostinazo
	// ServidorPHP servidor = new ServidorPHP("http://158.42.53.29");
	// String servidor = "http://158.42.53.29"; // En la UPV
	// String servidor = "http://192.168.1.150:8080"; // En mi casa

	BaseDatos db;
	Fichero fe;
	boolean ok;
	int aula = 0;
	Context v ;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		// Se crea una base de datos
		db = new BaseDatos(this, "encuesta");

		// Empezar la encuesta:

		Button boton;

		boton = (Button) findViewById(R.id.button1);
		i = new Intent(this, Encuesta.class);
        v = this;
		boton.setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				EditText t = (EditText) findViewById(R.id.editText1);
				Titulo_encuesta = t.getText().toString();

				// Envio msg de reserva.php
				CambiarAula();
				servidor.inicializa(aula); // Le cambio del aula
				ok = servidor.EnvioMensajeServidorReservar();
				if (ok) {

					// Borrar la base de datos para empezar encuesta
					db.Borrar();

					// Si no hay problemas, entonces se llama a encuesta
					// y se le pasa como parmetro el titulo de la misma.
					i.putExtra("titulo", Titulo_encuesta);
					startActivity(i);
				} else {
					Toast.makeText(v, "Cambia la clave de acceso", Toast.LENGTH_SHORT).show();
					
				}

			}
		});

		boton = (Button) findViewById(R.id.button2);
		j = new Intent(this, Resultados.class);

		fe = new Fichero("Prueba_v0.txt");

		boton.setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				String valor;
				Vector<String> v;
				Vector<Integer> ver;
				// Si la base de datos esta llena, es porque
				// la aplicacion se cerro sin generar el informe, se puede
				// generar desde aqui antes de otra nueva encuesta

				// Generar un informa del resultados, en mem. externa
				EditText t = (EditText) findViewById(R.id.editText1);
				Titulo_encuesta = t.getText().toString();
				v = db.LeerEntera();
				fe.Escribir(v, Titulo_encuesta);

				// Mostrar un grfico de aciertos/fallos
				j.putExtra("titulo", Titulo_encuesta);
				ver = db.Aciertos();

				float total = (float) (ver.get(0) + ver.get(1));
				float acierto = (float) ver.get(0) / total * 100;

				valor = String.format("%d", (int) acierto);
				j.putExtra("Aciertos", valor);
				valor = String.format("%d", 100 - (int) acierto);
				j.putExtra("Fallos", valor);
				startActivity(j);

			}
		});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			lanzarPreferencias(null);
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
	
	public void lanzarPreferencias(View view) {

		Intent i = new Intent(this, Preferencias.class);

		startActivity(i);

	}

	void CambiarAula() {
		SharedPreferences pref = getSharedPreferences(
				"com.example.profesor_preferences", Context.MODE_PRIVATE);

		String password = pref.getString("Password", "0");

		aula = Integer.parseInt(password);

		//Log.e("Password", password);
	}

}
